/**************************************************************************
 *                                                                        *
 *               Copyright (C) 1997, Dynamix, Inc.                        *
 *                                                                        *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Dynamix, Inc.,  and are      *
 *  protected by Federal copyright  law.  They  may not be disclosed to   *
 *  third parties  or copied or duplicated in any form, in whole or       *
 *  in part, without the prior written consent of Dynamix, Inc.           *
 *                                                                        *
 *************************************************************************/

#include <ultra64.h>
#include "logo.h"

/*
 * Sprite structure for the Dynamix logo, this logo is made out of
 * ten tiles. To simplify things each tile has size 24 x 78.
 * Note: the bitmap width image field value must be a 64bit aligned value
 *
 */

// #define NUM_LOGO_BM     10
#define NUM_LOGO_BM 1
static  Gfx     logosprite_dl[NUM_DL(NUM_LOGO_BM)];

/*
Bitmap logo_bitmap[NUM_LOGO_BM] = {
 { 24,24,0,0,piece1,78,0 }, { 24,24,0,0,piece2,78,0 },
 { 24,24,0,0,piece3,78,0 }, { 24,24,0,0,piece4,78,0 },
 { 24,24,0,0,piece5,78,0 }, { 24,24,0,0,piece6,78,0 },
 { 24,24,0,0,piece7,78,0 }, { 24,24,0,0,piece8,78,0 },
 { 24,24,0,0,piece9,78,0 }, { 24,24,0,0,piece10,78,0 }
};
*/
Bitmap logo_bitmap[NUM_LOGO_BM] = {
 { 236,236,0,0,deas,78,0 }
};


Sprite logo_sprite = {
 40,20,                 /* position: x,y */
 240,78,                /* sprite size in texels: x,y */
 1.0,1.0,               /* sprite scale: x,y */
 0,0,                   /* explosion: x,y */
 3,                     /* attribute: just copy :) */
 0x1234,                /* sprite depth: z */
 255,255,255,255,       /* sprite coloration RGBA */
 0,0,NULL,              /* color lookup table: start_index, length, address */
 0,1,                   /* sprite bitmap index: start_index, increment */
 NUM_LOGO_BM,           /* number of bitmaps */
 NUM_DL(NUM_LOGO_BM),   /* number of dl locations allocated */
 78,78,                 /* sprite bitmap height: used_height, physical height */
 G_IM_FMT_RGBA,         /* sprite bitmap format */
 G_IM_SIZ_16b,          /* sprite bitmap texel size */
 logo_bitmap,           /* pointer to bitmaps */
 logosprite_dl,         /* rsp_dl: display list memory */
 NULL,                  /* rsp_next_dl: dynamic_dl pointer */
 0,0                    /* texture fractional offsets */
};



void drawLogo(Gfx **glistp,f32 moveCnt)
{
  Gfx   *gxp,*dl;
  Sprite *sp = &logo_sprite;

  sp->rsp_dl = logosprite_dl;
  sp->rsp_dl_next = NULL;
//  sp->x = 40 + sinf(moveCnt/20)*60;
//  sp->y = 30 + sinf(moveCnt/25)*15;
// spScale(sp, 1.0+sinf(moveCnt/45)*0.5, 1.0);
  sp->x = 40;
  sp->y = 30;

  gxp = *glistp;

  dl = spDraw(sp);
  gSPDisplayList(gxp++, dl);
  *glistp = gxp;

}


