/*====================================================================
  File   : motor.h     Ver 1.8

  Copyright by Nintendo, Co., Ltd.     1997.
  ====================================================================*/

#include <ultra64.h>

#define NUM_ACCESS_MESG		1

static OSMesg	siAccessBuf[NUM_ACCESS_MESG];

OSMesgQueue	MotorSiAccessQueue;
int		MotorSiAccessQueueEnabled = 0;

void
MotorSiCreateAccessQueue(void)
{
    MotorSiAccessQueueEnabled = 1;

    osCreateMesgQueue(&MotorSiAccessQueue, siAccessBuf, NUM_ACCESS_MESG);

    /* Initialize the access queue with a resource token */
    (void)osSendMesg(&MotorSiAccessQueue, (OSMesg)0, OS_MESG_NOBLOCK);
}

void
MotorSiGetAccess(void)
{
    OSMesg dummyMesg;

    /* Create access message queue if haven't done so */
    if (!MotorSiAccessQueueEnabled) {
        MotorSiCreateAccessQueue();
    }

    (void)osRecvMesg(&MotorSiAccessQueue, &dummyMesg, OS_MESG_BLOCK);
}

void
MotorSiRelAccess(void)
{
    (void)osSendMesg(&MotorSiAccessQueue, (OSMesg)0, OS_MESG_NOBLOCK);
}


